//
//  MyDocument.m
//  Sprite Comic Helper
//
//  Created by Robert Ziefel on Fri Aug 30 2002.
//  Copyright (c) 2002 __MyCompanyName__. All rights reserved.
//

#import "MyDocument.h"
#import "sprite.h"

@implementation MyDocument

- (id)init
{
    [super init];
    if (self) {
        // Add your subclass-specific initialization here.
        // If an error occurs here, send a [self dealloc] message and return nil.
    
    }
    return self;
}

- (void)makeWindowControllers
{ // r1s3.3
  // Override method to instantiate controllers for the document's windows.
//    NSLog (@"theDocument here");
    if ( layers == nil ){
    layers = [NSMutableArray arrayWithCapacity : 1];
    allSprites = [NSMutableArray arrayWithCapacity : 2];
    borderArray = [NSMutableArray arrayWithCapacity : 1];
	dialogTracking = [NSMutableArray arrayWithCapacity: 1];
    }
//    else
//        NSLog (@"I will not touch the arrays' as I am loading");

    myController = [[controller allocWithZone:[self zone]] initWithWindowNibName :@"MyDocument"];
    [myController myDocumentIs :self];
    [myController useTheseArrays: layers :allSprites :borderArray :dialogTracking];

    // this makes memory space for controller and tells it about me, so the arrays can be joined
    [self addWindowController:myController];
    //    [controller release];		// Vermont R. has this being released, but I want the window! Why should I release it?
}

- (BOOL)writeToFile:(NSString *)fileName ofType:(NSString *)type
{
    // luckilly, I keep everything in the MutableArray, making this EASY!
    // any of the objects that conform to NSCopying protocol like NSArray, MutableArray, and others can be saved with just this line here.
    // don't ask why you don't need the path or anything, X just takes care of that for you.
    int lcv;
    NSMutableArray *spritesFlattened = [NSMutableArray arrayWithCapacity :[allSprites count]];
    NSMutableArray *otherStuff = [NSMutableArray arrayWithCapacity :1]; // anything else I can think of
    NSMutableDictionary *windowInfo = [NSMutableDictionary dictionaryWithCapacity: 1];

    NSFileWrapper *whyNotTryIt;

    fileSavedTo = [NSMutableString stringWithCapacity:10];
    [fileSavedTo setString :fileName];
    [fileSavedTo retain];
    
//    NSLog (@"trying to save to %@", fileName);
    [[NSFileManager defaultManager] createDirectoryAtPath: fileName attributes:nil];
    whyNotTryIt = [[NSFileWrapper alloc] initWithPath:fileName];
    if (![whyNotTryIt isDirectory])
//       NSLog (@"It's a directory all right");
//    else
        return NO;

//    NSLog ([NSString stringWithFormat :@"%@/layers.plist", fileName], fileName);
//    NSLog (@"***And I'm going to use %@", [spritesToSave description]);
    if ( ![whyNotTryIt writeToFile:fileName atomically:YES updateFilenames:YES] )
        return NO; // I have to do this first because it doesn't exist in the right place until I do

    if (![layers writeToFile :[NSString stringWithFormat :@"%@/layers.plist", fileName] atomically:YES])
        return NO; // then I can do this, and have everything nice and written to the right folder.
	
	if (![dialogTracking writeToFile :[NSString stringWithFormat :@"%@/dialog.plist", fileName] atomically:YES])
        return NO; // then I can do this, and have everything nice and written to the right folder.

    for (lcv = 0; lcv < [allSprites count]; lcv++){

        NSMutableDictionary *record = [NSMutableDictionary dictionaryWithCapacity: 1];
        [record setObject:[NSNumber numberWithInt :lcv] forKey:@"spriteNumber"];
        [record setObject:[NSNumber numberWithDouble :[[allSprites objectAtIndex: lcv] currentRect].origin.x] forKey:@"startX"];
        [record setObject:[NSNumber numberWithDouble :[[allSprites objectAtIndex: lcv] currentRect].origin.y] forKey:@"startY"];
        [record setObject:[NSNumber numberWithDouble :[[allSprites objectAtIndex: lcv] currentRect].size.width] forKey:@"width"];
        [record setObject:[NSNumber numberWithDouble :[[allSprites objectAtIndex: lcv] currentRect].size.height] forKey:@"height"];
        [record setObject:[NSNumber numberWithInt :[[allSprites objectAtIndex: lcv] layer]] forKey:@"layer"];
        [[[[allSprites objectAtIndex: lcv] sprite] TIFFRepresentation] writeToFile:[NSString stringWithFormat :@"%@/%d.tiff", fileName, lcv] atomically:YES];
        [spritesFlattened addObject :record];
    }
    if (![spritesFlattened writeToFile :[NSString stringWithFormat :@"%@/sprites.plist", fileName] atomically:YES])
        return NO; // then I can do this, and have everything nice and written to the right folder.

    [windowInfo setObject:[NSNumber numberWithInt :[myController windowSize].width] forKey :@"width"];
    [windowInfo setObject:[NSNumber numberWithInt :[myController windowSize].height] forKey :@"height"];
    
    [otherStuff addObject :windowInfo]; // that should get written out ok...

    if (![otherStuff writeToFile :[NSString stringWithFormat :@"%@/other.plist", fileName] atomically:YES])
        return NO; // then I can do this, and have everything nice and written to the right folder.

    if (![borderArray writeToFile :[NSString stringWithFormat :@"%@/borders.plist", fileName] atomically:YES])
        return NO;

    // we made it!
    return YES;
}

- (BOOL)readFromFile:(NSString *)path ofType:(NSString *)type
{
    // Man, I am loving how easy save and load is. Took me forever to figure this out though
    NSMutableArray *spritesFlattened = [NSMutableArray arrayWithCapacity :1];
    NSMutableArray *otherStuff = [NSMutableArray arrayWithCapacity :1];
    int lcv;

    fileSavedTo = [NSMutableString stringWithCapacity:10];
    [fileSavedTo setString :path];
    [fileSavedTo retain];
    
    allSprites = [NSMutableArray arrayWithCapacity :1];
//    NSLog (type);
    if (path != nil && [type isEqualTo :@"Sprite Comic Document"]){
 //       NSLog (@"I am loading a file");
        layers = [[NSMutableArray allocWithZone:[self zone]] initWithContentsOfFile:[NSString stringWithFormat :@"%@/layers.plist", path]];
        [layers retain];
		
		if ( [[NSFileManager defaultManager] fileExistsAtPath: [NSString stringWithFormat :@"%@/dialog.plist", path]] ){
			dialogTracking = [[NSMutableArray allocWithZone:[self zone]] initWithContentsOfFile:[NSString stringWithFormat :@"%@/dialog.plist", path]];
			[dialogTracking retain];
		}	else { // I'm opening a document that didn't have any, like from a previous version of this tool?
			dialogTracking = [NSMutableArray arrayWithCapacity : 1];
			[dialogTracking retain];
		}

        // as I have saved it as xml code with "descrpition" above, I just create space for the array, and call initWith... to load it.
        spritesFlattened = [[NSMutableArray allocWithZone:[self zone]] initWithContentsOfFile:[NSString stringWithFormat :@"%@/sprites.plist", path]];
        for (lcv = 0; lcv < [spritesFlattened count]; lcv++){
//            NSLog (@"Loading sprite %@/%d.tiff", path, lcv);
            sprite *newSprite = [[sprite alloc] init: [[NSImage alloc] initWithContentsOfFile:[NSString stringWithFormat :@"%@/%d.tiff", path, lcv]]
        :NSMakeRect(0, 0,
        [[[spritesFlattened objectAtIndex :lcv] objectForKey :@"width"] floatValue],
        [[[spritesFlattened objectAtIndex :lcv] objectForKey :@"height"] floatValue])
            :[[[spritesFlattened objectAtIndex :lcv] objectForKey :@"layer"] floatValue]];
            [newSprite setRect :NSMakeRect ([[[spritesFlattened objectAtIndex :lcv] objectForKey :@"startX"] floatValue],
                [[[spritesFlattened objectAtIndex :lcv] objectForKey :@"startY"] floatValue],
                [[[spritesFlattened objectAtIndex :lcv] objectForKey :@"width"] floatValue],
                [[[spritesFlattened objectAtIndex :lcv] objectForKey :@"height"] floatValue] )];
            [allSprites addObject :newSprite];
            
        }
        [allSprites retain];
        otherStuff = [[NSMutableArray allocWithZone:[self zone]] initWithContentsOfFile:[NSString stringWithFormat :@"%@/other.plist", path]];
        windowCoords = NSMakeRect (0, 0, [[[otherStuff objectAtIndex :0] objectForKey :@"width"] floatValue], [[[otherStuff objectAtIndex :0] objectForKey :@"height"] floatValue] );

//        NSLog (@"What's going on");
        if ( [[NSFileManager defaultManager] fileExistsAtPath: [NSString stringWithFormat :@"%@/borders.plist", path]] ){
//            NSLog (@"Yes, it did");
        borderArray = [[NSMutableArray allocWithZone:[self zone]] initWithContentsOfFile:[NSString stringWithFormat :@"%@/borders.plist", path]];
        }
        else{ // I'm opening a document that didn't have any, like from a previous version of this tool?
            borderArray = [NSMutableArray arrayWithCapacity : 1];
//            NSLog (@"No, it didn't");
        }
 //       NSLog ([spritesFlattened description]);
        // this is the only thing that needs to go across.
        return YES;
    }
    else
        return NO;
    // there could be other things that go wrong, but I have no idea how to check for them
}

- (NSRect) windowCoords
{
    return windowCoords;
}

- (NSMutableString *)fileOpenedFrom
{
    return fileSavedTo;
}

@end
