/*
 IMPORTANT:  This software is supplied to you by Silverstreak Software. In
 consideration of your agreement to the following terms, and your use, installation,
 modification or redistribution of this Silverstreak software constitutes acceptance of these
 terms.  If you do not agree with these terms, please do not use, install, modify or
 redistribute this Silverstreak software.

 In consideration of your agreement to abide by the following terms, and subject to these
 terms, Silverstreak Software grants you a personal, non-exclusive license, under Robert Ziefels copyrights in
 this original Silverstreak software (the "Silverstreak Software"), to use, reproduce, modify and
 redistribute the Silverstreak Software, with or without modifications, in source and/or binary
 forms; provided that if you redistribute the software in its entirety and without
 modifications, you must retain this notice and the following text and disclaimers in all
 such redistributions of the software.  Neither the name, trademarks, service marks
 or logos of Silverstreak Software may be used to endorse or promote products derived from
 the Silverstreak Software without specific prior written permission from Robert Ziefel. Except as expressly
 stated in this notice, no other rights or licenses, express or implied, are granted by Robert Ziefel herein, including but not limited to any patent rights that may be infringed by your
 derivative works or by other works in which the Silverstreak Software may be incorporated.

 The Silverstreak Software is provided by Silverstreak on an "AS IS" basis.  Robert Ziefel MAKES NO WARRANTIES,
 EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION THE IMPLIED WARRANTIES OF NON-INFRINGEMENT,
 MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE, REGARDING THE SOFTWARE OR ITS
 USE AND OPERATION ALONE OR IN COMBINATION WITH YOUR PRODUCTS.

 IN NO EVENT SHALL ROBERT ZIEFEL BE LIABLE FOR ANY SPECIAL, INDIRECT, INCIDENTAL OR CONSEQUENTIAL
 DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
          OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) ARISING IN ANY WAY OUT OF THE USE,
 REPRODUCTION, MODIFICATION AND/OR DISTRIBUTION OF THE Silverstreak SOFTWARE, HOWEVER CAUSED AND
 WHETHER UNDER THEORY OF CONTRACT, TORT (INCLUDING NEGLIGENCE), STRICT LIABILITY OR
 OTHERWISE, EVEN IF ROBERT ZIEFEL HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#import <Cocoa/Cocoa.h>
#import "MyDocument.h"
#import "myWindow.h"

@class MyView;
@class MyDocument;
@class myWindow;

@interface controller : NSWindowController
{

    IBOutlet NSWindow *layerPallet;
    IBOutlet NSWindow *spritePallet;
    IBOutlet NSWindow *toolsPallet;
    IBOutlet NSWindow *scaleWindow;
    IBOutlet NSWindow *rotateWindow;
    IBOutlet NSWindow *transparentWindow;
    IBOutlet NSWindow *dialogWindow;
    IBOutlet NSWindow *preferencesWindow;
    IBOutlet NSWindow *closeWarningWindow;
    IBOutlet NSTableView *layerTable;
    IBOutlet NSTableView *spriteTable;
    IBOutlet NSTextField *heightBox;
    IBOutlet NSTextField *widthBox;
    IBOutlet NSTextField *scaleBox;
    IBOutlet NSTextField *rotateBox;
    IBOutlet NSTextField *transparencyBox;
    IBOutlet NSTextView *dialogCreationBox;
    IBOutlet NSWindow *howBigWindow;
    IBOutlet NSButton *arrowTool;
    IBOutlet NSButton *boxTool;
    IBOutlet NSButton *dialogTool;
    IBOutlet NSButton *bubbleTool;
    IBOutlet NSButton *thoughtBubbleTool;
    IBOutlet NSButton *cropButtonTool;
    
    IBOutlet NSFontManager *fontManager;
    IBOutlet NSColorWell *colorSelector;
    IBOutlet id defaultSaveFormat;
    IBOutlet NSView *formatView;
    IBOutlet id actualSaveFormat;
    
    myWindow *window;
    
    NSScrollView *scrollView;

    NSMutableArray *sprites; // these are the sprites in the pallet
    NSMutableArray *allSprites; // these are the sprites in the window!
    NSMutableArray *bordersArray;
	NSMutableArray *dialogTracking;

    NSMutableArray *layers;
    MyView *theComicView;
    
    int layerIncrementor;
    int state;
    int width, height;
	int changingText;
    
    MyDocument *myDocument;

    NSMutableString *spritesComeFrom;
}
- (void)changeFont:(id)sender;
- (BOOL)fontManager:(id)theFontManager willIncludeFont:(NSString *)fontName;

- (void)windowWillLoad;
- (void)windowDidLoad;
- (void)myDocumentIs :(MyDocument *)document;
- (void)useTheseArrays: (NSMutableArray *)layers :(NSMutableArray *)sprites :(NSMutableArray *)borders :(NSMutableArray *)dialogArray;
- (void)useThisNumberOfLayers:(int)layerNumber;
- (id)initWithWindowNibName:(NSString *)windowW;
- (void)nudge:(int)hor :(int)vert;
- (IBAction)cancelNew:(id)sender;

- (IBAction)chooseArrowTool:(id)sender;
- (IBAction)chooseBoxTool:(id)sender;
- (IBAction)chooseBubbleTool:(id)sender;
- (IBAction)chooseThoughtBubbleTool:(id)sender;
- (IBAction)chooseDialogTool:(id)sender;
- (IBAction)chooseCropTool:(id)sender;

- (IBAction)clear:(id)sender;
- (IBAction)copy:(id)sender;
- (IBAction)cut:(id)sender;
- (IBAction)del:(id)sender;
- (void)dealloc;
- (IBAction)down:(id)sender;
- (IBAction)mirrorLeftAndRight:(id)sender;
- (IBAction)mirrorUpAndDown:(id)sender;
- (void)newComic;
- (IBAction)newNew:(id)sender;
- (IBAction)newLayer:(id)sender;
- (IBAction)paste:(id)sender;
- (IBAction)duplicate:(id)sender;
- (IBAction)removeBoarders:(id)sender;

- (IBAction)rotateCancelButton:(id)sender;
- (IBAction)rotateOkButton:(id)sender;
- (IBAction)showRotateWindow:(id)sender;

- (IBAction)transparentCancelButton:(id)sender;
- (IBAction)transparentOkButton:(id)sender;
- (IBAction)showtransparentWindow:(id)sender;

- (IBAction)export:(id)sender;
- (IBAction)save:(id)sender;
- (IBAction)saveAs:(id)sender;

- (IBAction)scaleCancelButton:(id)sender;
- (IBAction)scaleOkButton:(id)sender;
- (IBAction)showScaleWindow:(id)sender;

- (IBAction)closeCancelButton:(id)sender;
- (IBAction)closeSaveButton:(id)sender;
- (IBAction)cancelCloseButton:(id)sender;
- (IBAction)showCloseWarningWindow:(id)sender;

- (IBAction)preferencesSaveButton:(id)sender;
- (IBAction)showpreferencesWindow:(id)sender;

- (IBAction)dialogCancelButton:(id)sender;
- (IBAction)dialogOkButton:(id)sender;

- (IBAction)up:(id)sender;
- (IBAction)openSprites:(id)sender;
- (IBAction)reopenSprites:(id)sender;

- (id)tableView:(NSTableView *)aTableView objectValueForTableColumn:(NSTableColumn *)aTableColumn row:(int)rowIndex;
- (void)tableView:(NSTableView *)aTableView setObjectValue:anObject forTableColumn:(NSTableColumn *)aTableColumn row:(int)rowIndex;
- (int)numberOfRowsInTableView:(NSTableView *)aTableView;
- (void)changeLayer;
- (NSSize)windowSize;

@end
