#import "controller.h"
#import "MyView.h"

// ummm, right now, these do NOTHING, as I ask "firstResponder.newDocument" for a new
// document, which makes a whole new controller! This is bad because I ask myView
// to export the document, but if you have two open, you only get one of them, no matter if
// you switch them or not. Oops. well, uh... !!!!!
#define documentOpen 0
#define readyToOpen 1

// 1.1
/*
 Fixed the bug that caused pasting a sprite to place it in the wrong layer
 Fixed the bug that kept the last pasted sprite as the active one even when not pointing to it
 No longer clear clipboard after a paste, so you can paste multiple times
 Added a duplicate command
 Added my own file foramt so you can now save and export
*/

@implementation controller


- (void)windowWillLoad
{
//    NSLog (@"windowWillLoad");

//    window = [[NSWindow alloc] initWithContentRect: NSMakeRect( 0, 0, [[widthBox stringValue] intValue], [[heightBox stringValue] intValue] ) styleMask:NSTitledWindowMask | NSMiniaturizableWindowMask backing:NSBackingStoreBuffered defer:YES];

}

- (void)windowDidLoad
{
//    NSLog (@"windowDidLoad");
    NSMutableDictionary *layerZero= [NSMutableDictionary dictionaryWithCapacity: 1];
    id imageCell;
    NSTableColumn *theColumn;
	
	changingText = 0;

    if ( [layers count] == 0 ){ // if I already have layers, I don't need another layer 0!
        [layerZero setObject :@"100" forKey:@"transparency"];
        [layerZero setObject :@"0" forKey:@"layer"];
        [layers addObject :layerZero]; // now I have one 100% opaque layer
    }

    layerIncrementor = [layers count];
    if ( layerIncrementor != 0 )
        layerIncrementor--; // if I have 5 layers, next is 5, as first was 0
    [layers retain];
    [sprites retain];

    theColumn=[spriteTable tableColumnWithIdentifier:@"row1"];
    imageCell=[NSImageCell new];
    [theColumn setDataCell:imageCell];

    [spriteTable setDoubleAction:@selector(addCharacter)];
    [spriteTable setTarget:self];
    [layerTable setDoubleAction:@selector(changeLayer)];
    [layerTable setTarget:self];

    [arrowTool setState :NSOnState];
    spritesComeFrom = [NSMutableString stringWithCapacity:10];
    [spritesComeFrom retain];

    [dialogCreationBox setContinuousSpellCheckingEnabled :YES];
    [dialogCreationBox setUsesFontPanel: YES];
    [self newComic];

}


- (id)initWithWindowNibName:(NSString *)windowW
{
    [super initWithWindowNibName: windowW];
    state = readyToOpen;
//    NSLog (@"initWithWindowNibName");
    return self;
}

- (void)nudge:(int)hor :(int)vert
{
    [theComicView nudge :hor :vert]; // seesh, pass the buck, why don't cha!
}

- (void)myDocumentIs :(MyDocument *)document
{
    myDocument = document;
}

- (void)useTheseArrays: (NSMutableArray *)layersA :(NSMutableArray *)spritesA :(NSMutableArray *)borderArray :(NSMutableArray *)dialogArray
{
//    NSLog (@"I will use these arrays %d", [spritesA count]);
    layers = [layersA retain];
    sprites = [NSMutableArray arrayWithCapacity :1];
    [sprites retain];
    allSprites = [spritesA retain];
    bordersArray = [borderArray retain];
	dialogTracking = [dialogArray retain];
}

- (void)addCharacter
{
    // I have to look at what number I'm pointing to, so I get the from the layers array
    [theComicView addCharacter: [sprites objectAtIndex: [spriteTable selectedRow]] :[[[layers objectAtIndex :[layers count] - [layerTable selectedRow] - 1 ] objectForKey :@"layer"] intValue] :[scrollView documentVisibleRect].origin.x :[scrollView documentVisibleRect].origin.y];
    [self changeLayer];
    [myDocument updateChangeCount: NSChangeDone];
}

- (IBAction)cancelNew:(id)sender
{
    [howBigWindow close];
    [widthBox setObjectValue :@""];
    [heightBox setObjectValue :@""];
}

-(void)changeLayer
{
    [theComicView changeLayer: [[[layers objectAtIndex :[layers count] - [layerTable selectedRow] - 1] objectForKey :@"layer"] intValue]];
    [window makeKeyAndOrderFront: self]; // don't ask why, but I have to do this or click twice on the window
    [theComicView setNeedsDisplay :YES];
}

- (IBAction)chooseArrowTool:(id)sender
{
    [theComicView toolChange: 0];
    [boxTool setState :NSOffState];
    [bubbleTool setState :NSOffState];
    [cropButtonTool setState :NSOffState];
    [dialogTool setState :NSOffState];
    [thoughtBubbleTool setState :NSOffState];
    [window makeKeyAndOrderFront: self]; // don't ask why, but I have to do this or click twice on the window
//    NSLog ( @"%f %f %f %f", [scrollView documentVisibleRect].origin.x, [scrollView documentVisibleRect].origin.y, [scrollView visibleRect].size.width, [scrollView visibleRect].size.height);

}

- (IBAction)chooseBoxTool:(id)sender
{
    [theComicView toolChange: 2];
    [arrowTool setState :NSOffState];
    [cropButtonTool setState :NSOffState];
    [bubbleTool setState :NSOffState];
    [dialogTool setState :NSOffState];
    [thoughtBubbleTool setState :NSOffState];
    [window makeKeyAndOrderFront: self]; // don't ask why, but I have to do this or click twice on the window
}

- (IBAction)chooseBubbleTool:(id)sender
{
    [theComicView toolChange: 3];
    [boxTool setState :NSOffState];
    [arrowTool setState :NSOffState];
    [cropButtonTool setState :NSOffState];
    [dialogTool setState :NSOffState];
    [thoughtBubbleTool setState :NSOffState];
    [window makeKeyAndOrderFront: self]; // don't ask why, but I have to do this or click twice on the window
}

- (IBAction)chooseThoughtBubbleTool:(id)sender
{
    [theComicView toolChange: 4];
    [boxTool setState :NSOffState];
    [arrowTool setState :NSOffState];
    [bubbleTool setState :NSOffState];
    [cropButtonTool setState :NSOffState];
    [dialogTool setState :NSOffState];
    [window makeKeyAndOrderFront: self]; // don't ask why, but I have to do this or click twice on the window
    
}

- (IBAction)chooseDialogTool:(id)sender
{
    [boxTool setState :NSOffState];
    [arrowTool setState :NSOffState];
    [dialogTool setState :NSOnState];
    [cropButtonTool setState :NSOffState];
    [thoughtBubbleTool setState :NSOffState];    
    [[NSFontManager sharedFontManager] orderFrontFontPanel:self];
	if ( [theComicView shouldEdit] == TRUE ){
		changingText = 1;
		[dialogCreationBox setString: [theComicView textToEdit]];
	}
	else {
		changingText = 0;
		[dialogCreationBox setString :@""]; // clear out the old
	}
	
	[dialogWindow center];
	[dialogWindow makeKeyAndOrderFront: self];
	
    
}

- (IBAction)chooseCropTool:(id)sender
{
    [theComicView toolChange: 10];
    [boxTool setState :NSOffState];
    [arrowTool setState :NSOffState];
    [dialogTool setState :NSOffState];
    [thoughtBubbleTool setState :NSOffState];
    [cropButtonTool setState :NSOnState];
    [window makeKeyAndOrderFront: self]; // don't ask why, but I have to do this or click twice on the window

}


- (void)changeFont:(id)sender
{
//    NSLog (@"Yoooooo");
}

- (BOOL)fontManager:(id)theFontManager willIncludeFont:(NSString *)fontName
{
    return YES;
}

- (IBAction)clear:(id)sender
{
    [theComicView deleteSprite];
}

- (IBAction)copy:(id)sender
{
    [theComicView copySprite];
}

- (IBAction)cut:(id)sender
{
    [theComicView cutSprite];
}

- (IBAction)del:(id)sender
{
    if ( [layers count] > 1 ){
        [theComicView deleteLayer :[[[layers objectAtIndex :[layers count] - [layerTable selectedRow] - 1 ] objectForKey :@"layer"] intValue]];
        [layers removeObjectAtIndex:[layers count] - [layerTable selectedRow] - 1 ];
        [layerTable reloadData];
        [theComicView changeLayer: [[[layers objectAtIndex :[layers count] - [layerTable selectedRow] - 1 ] objectForKey :@"layer"] intValue]];
    }
    [window makeKeyAndOrderFront: self]; // don't ask why, but I have to do this or click twice on the window
}

- (void)dealloc
{
    [sprites removeAllObjects];
    [spritesComeFrom release];
    [bordersArray removeAllObjects];
    [bordersArray release];
//    [chosenSprites removeAllObjects];
    [layers removeAllObjects];
    [theComicView release];
    [scrollView release];
	[super dealloc];
    
}

- (IBAction)mirrorLeftAndRight:(id)sender
{
    [theComicView mirrorSprite :-1 :1];
    [myDocument updateChangeCount: NSChangeDone];
}

- (IBAction)mirrorUpAndDown:(id)sender
{
    [theComicView mirrorSprite :1 :-1];
    [myDocument updateChangeCount: NSChangeDone];
}

- (IBAction)down:(id)sender // Yes, it seems backwards because it is. I'm moving the ARRAY value to the right,
                            // and the table representation lower, so I need a + 1 not a - 1
{
    if ( [layerTable selectedRow] < [layers count] - 1){
        id theLayer = [[layers objectAtIndex:[layers count] - [layerTable selectedRow] - 1] retain];
        [layers removeObjectAtIndex:[layers count] - [layerTable selectedRow] - 1];
        [layers insertObject :theLayer atIndex:[layers count] - [layerTable selectedRow] - 1];
        [layerTable selectRow :[layerTable selectedRow] + 1 byExtendingSelection:NO];
        [self changeLayer];
    }    
    [layerTable reloadData];
    [myDocument updateChangeCount: NSChangeDone];
}

- (void)useThisNumberOfLayers:(int)layerNumber;
{
    layerIncrementor = layerNumber;
}

- (void)newComic;
{
    if ( state == readyToOpen ){
        if ( [allSprites count] == 0 ){
        NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
            [[self window] makeFirstResponder: widthBox];

        [widthBox setIntValue :[defaults integerForKey:@"width"]];
        [heightBox setIntValue :[defaults integerForKey:@"height"]];
        [howBigWindow center];
        [howBigWindow makeKeyAndOrderFront :self];
        state = documentOpen;
//        NSLog (@"new comic");
        }
        else {
            [self newNew:self];
        }
    }
    else
        NSRunAlertPanel(@"My Apologies",@"Currently, I can only support one open comic at a time. Please save and close the current document",@"OK",NULL,NULL);
}

- (IBAction)newLayer:(id)sender
{
    NSMutableDictionary *nextLayer= [NSMutableDictionary dictionaryWithCapacity: 1];
    layerIncrementor++; // I want each one to be unique, so if you erase layer 3 you don't get it back, you get 4

//NSLog (@"%f and I'm adding it to %d", [transparencySlider floatValue], [layers count] - [layerTable selectedRow]);
    [nextLayer setObject :[NSString stringWithFormat: @"%d", layerIncrementor ] forKey:@"layer"];

    [layers insertObject :nextLayer atIndex:[layers count] - [layerTable selectedRow]]; // now I have one more x% opaque layer, and it's "higher" then  the ones before it
        // what I'm doing is reordering them because I just put one in the middle

    [layerTable reloadData];

    [self changeLayer];
    [myDocument updateChangeCount: NSChangeDone];
    [window makeKeyAndOrderFront: self]; // don't ask why, but I have to do this or click twice on the window
}

-(IBAction)newNew:(id)sender
{
//    NSLog (@"newNew has been called");
    if ( [allSprites count] != 0 ){
        [widthBox setObjectValue :[NSString stringWithFormat :@"%f", [myDocument windowCoords].size.width]];
        [heightBox setObjectValue :[NSString stringWithFormat :@"%f", [myDocument windowCoords].size.height]];
//        NSLog (@"%f, %f", [myDocument windowCoords].size.width, [myDocument windowCoords].size.height);
    }
    
    if ( ![[widthBox stringValue] isEqual :@""] && ![[heightBox stringValue] isEqual :@""] ){
        NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];

        NSScreen *mainScreen = [NSScreen mainScreen];

        if ( [defaults integerForKey:@"layersX"] == nil ){
            [defaults setInteger:889 forKey:@"layersX"];
            [defaults setInteger:48 forKey:@"layersY"];
            [defaults setInteger:803 forKey:@"spriteX"];
            [defaults setInteger:276 forKey:@"spriteY"];
            [defaults setInteger:795 forKey:@"toolsX"];
            [defaults setInteger:52 forKey:@"toolsY"];
        }
        
        [defaults setInteger:[heightBox intValue] forKey:@"height"];
        [defaults setInteger:[widthBox intValue] forKey:@"width"];
        
        [defaults synchronize];
        [howBigWindow close];
        
            theComicView = [[MyView alloc] initWithFrame: NSMakeRect( 0, 0, [[widthBox stringValue] intValue], [[heightBox stringValue] intValue] )];
            [theComicView retain];

            scrollView = [[NSScrollView alloc] initWithFrame: NSMakeRect( 0, 0, [[widthBox stringValue] intValue], [[heightBox stringValue] intValue])];
            [scrollView retain];

            [scrollView setDocumentView: theComicView];
            [theComicView useTheseThings: layers :allSprites :bordersArray :dialogTracking];
//            NSLog (@"%f", [mainScreen visibleFrame].size.height);
//            NSLog (@"%f", [mainScreen visibleFrame].size.width);
            if ( [mainScreen visibleFrame].size.height < [heightBox intValue]){
                height = [mainScreen visibleFrame].size.height;
                [scrollView setHasVerticalScroller: YES];
                width = 15; // as the scroller takes up some of my window
            }
            else
                height = [heightBox intValue];

            if ( [mainScreen visibleFrame].size.width < [widthBox intValue]){
                width += [mainScreen visibleFrame].size.width;
                [scrollView setHasHorizontalScroller: YES];
                height += 15;
            }
            else
                width += [widthBox intValue];
            
//            NSLog (@"%d", width);

            [scrollView setFrame :NSMakeRect( 0, 0, width, height )];
//            NSLog ( @"%f %f %f %f", [scrollView visibleRect].origin.x, [scrollView visibleRect].origin.y, [scrollView visibleRect].size.width, [scrollView visibleRect].size.height );

            window = [[myWindow alloc] initWithContentRect: NSMakeRect( 0, 0, width, height ) styleMask:NSTitledWindowMask | NSMiniaturizableWindowMask backing:NSBackingStoreBuffered defer:YES];
             [window setFrame:NSMakeRect([mainScreen frame].size.width - [mainScreen visibleFrame].size.width, [mainScreen frame].size.height - [mainScreen visibleFrame].size.height, width, height + 22) display:YES];
            [window setContentView :scrollView];
            [window setController: self];
            // the title bar is 22 big, so I must ask for that in additon to what I want
//            [window setFrame:NSMakeRect( 0, 0, [[widthBox stringValue] intValue], [[heightBox stringValue] intValue]  + 22) display:YES];
            [window makeFirstResponder :theComicView];
            [window setTitle: @"Comic"];
            [layerPallet makeFirstResponder :theComicView];
            [spritePallet makeFirstResponder :theComicView];
            [toolsPallet makeFirstResponder :theComicView];
        
        if ( [sprites count] == 0 )
            [self openSprites: sender];
        [layerPallet setFrame :NSMakeRect ([defaults integerForKey:@"layersX"], [defaults integerForKey:@"layersY"], 134, 212) display:NO];
        [layerPallet orderFront :sender];
        [layerTable reloadData];
        [spritePallet setFrame :NSMakeRect ([defaults integerForKey:@"spriteX"], [defaults integerForKey:@"spriteY"], 217, 464) display:NO];
        [spritePallet orderFront :sender];
        [spriteTable reloadData];
        [toolsPallet setFrame :NSMakeRect ([defaults integerForKey:@"toolsX"], [defaults integerForKey:@"toolsY"], 84, 208) display:NO];
        [toolsPallet orderFront :sender];
        state = documentOpen;
        [window makeKeyAndOrderFront :sender];
        [theComicView scrollPoint: NSMakePoint (width, height)]; // scroll to the top

        if ( [myDocument fileOpenedFrom] == nil ){ // don't add another bg layer
            // if you're opening the file from the disk!
            NSColor * aColor =nil;
            NSData *theData= [[NSUserDefaults standardUserDefaults] dataForKey:@"backgroundColor"];
            if (theData != nil){
                aColor =(NSColor *)[NSUnarchiver unarchiveObjectWithData:theData];
    
                NSImage *background = [[NSImage alloc] initWithSize: NSMakeSize([[widthBox stringValue] intValue], [[heightBox stringValue] intValue])];
                [background lockFocus];
                [aColor set];
                NSRectFill (NSMakeRect (0, 0, [[widthBox stringValue] intValue], [[heightBox stringValue] intValue]));
                [background unlockFocus];
                [theComicView addCharacter: background :0 :0 :0];
                [self newLayer:self];
            }
        }
    }            

}

- (IBAction)openSprites:(id)sender
{
    NSOpenPanel *oPanel;
    int runResult;
    oPanel = [NSOpenPanel openPanel];

    [oPanel setAllowsMultipleSelection:NO];
    [oPanel setCanChooseDirectories: YES];
    [oPanel setCanChooseFiles:NO];

    runResult = [oPanel runModalForTypes:nil];

    if (runResult == NSOKButton) {
        id object;
        NSEnumerator *enumerator_;
        [sprites removeAllObjects];
//        NSLog ([[oPanel filenames] objectAtIndex:0]);
        [spritesComeFrom setString :[[oPanel filenames] objectAtIndex:0]];
        enumerator_= [[NSFileManager defaultManager] enumeratorAtPath:spritesComeFrom];
        while ((object = [enumerator_ nextObject])) {
			// I have having a problem loading my sprites, and it turned out to be a .xvpics folder that popped up someplace.
			// this folder had some nutty empty tiffs in it, which of course my adding to array code didn't like (crash)
			// this checks for invisable folders and skips them, should they exist
			if ( [object rangeOfString :@"/." options:NSCaseInsensitiveSearch | NSLiteralSearch].length == 0 ){
				 if ( [object hasSuffix: @".tiff"] || [object hasSuffix: @".tif"] || [object hasSuffix: @".TIFF"] || [object hasSuffix: @".TIF"]){

			//                NSMutableDictionary *nextSprite= [NSMutableDictionary dictionaryWithCapacity: 1];
			//                [nextSprite setObject :[NSString stringWithFormat :@"%@/%@",[[oPanel filenames] objectAtIndex:0], object] forKey:@"row1"];
					 [sprites addObject :[[NSImage alloc] initWithContentsOfFile:[NSString stringWithFormat :@"%@/%@", [[oPanel filenames] objectAtIndex:0], object]]];
			//                [sprites addObject :nextSprite];
				}
			}
		}
 //       NSLog (@"%d", [sprites count]);
    }
    [spriteTable reloadData];
}

- (IBAction)reopenSprites:(id)sender
{
    id object;
    NSEnumerator *enumerator_;
    [sprites removeAllObjects];
    //        NSLog ([[oPanel filenames] objectAtIndex:0]);
    enumerator_= [[NSFileManager defaultManager] enumeratorAtPath:spritesComeFrom];
    while ((object = [enumerator_ nextObject])) {
        if ( [object hasSuffix: @".tiff"] ){
            [sprites addObject :[[NSImage alloc] initWithContentsOfFile:[NSString stringWithFormat :@"%@/%@", spritesComeFrom, object]]];
        }
    }

[spriteTable reloadData];
}

- (IBAction)duplicate:(id)sender
{
    [self copy: sender];
    [self paste:sender];
    [myDocument updateChangeCount: NSChangeDone];
}

- (IBAction)paste:(id)sender
{
    [theComicView changeLayer: [[[layers objectAtIndex :[layers count] - [layerTable selectedRow] - 1 ] objectForKey :@"layer"] intValue]];
    [theComicView pasteSprite :[scrollView documentVisibleRect].origin.x :[scrollView documentVisibleRect].origin.y];
    [myDocument updateChangeCount: NSChangeDone];
}

- (IBAction)rotateCancelButton:(id)sender
{
    [rotateWindow close];    
}

- (IBAction)rotateOkButton:(id)sender
{
    if ( [rotateBox intValue] >= -360 && [rotateBox intValue] <= 360 ){
        [rotateWindow close];        
        [theComicView rotateCurrentSprite :[rotateBox intValue]];
        [myDocument updateChangeCount: NSChangeDone]; // !!!!! What I really need to do is override the quit function, have my own var that tracks if it's been saved, and go from there.
        // but this will at least protect me for now....
    } else
        NSRunAlertPanel(@"My Apologies",@"Please enter a value between -360 and 360.",@"OK",NULL,NULL);
    
}

- (IBAction)removeBoarders:(id)sender
{
    [theComicView removeBoarders]; // that's me, always delegating!

}

- (IBAction)save:(id)sender
{

    if ( [myDocument fileOpenedFrom] != nil){
        [myDocument writeToFile :[myDocument fileOpenedFrom] ofType:@"schd"];
        [myDocument updateChangeCount: NSChangeCleared];
    }
    else
        [self saveAs:sender];
}

- (IBAction)saveAs:(id)sender
{
    NSSavePanel *sp;
    int runResult;

    sp = [NSSavePanel savePanel];
    [sp setRequiredFileType:@"schd"];

    runResult = [sp runModal];
    if (runResult == NSOKButton){
        [myDocument writeToFile :[sp filename] ofType:@"schd"];
        [myDocument updateChangeCount: NSChangeCleared];
    }
}

- (IBAction)export:(id)sender
{
    NSSavePanel *sp;
    int runResult;
    int formatInt = [[NSUserDefaults standardUserDefaults] integerForKey:@"defaultFormat"];
    [actualSaveFormat selectItemAtIndex: formatInt];

    sp = [NSSavePanel savePanel];
    [sp setAccessoryView: formatView];

    runResult = [sp runModal];
    if (runResult == NSOKButton){
        [theComicView saveImage :[sp filename]];
    }
}

- (IBAction)dialogCancelButton:(id)sender
{
    [[[NSFontManager sharedFontManager] fontPanel:NO] close];
    [dialogWindow close];    
    [window makeKeyAndOrderFront: self]; // don't ask why, but I have to do this or click twice on the window
}

// I don't think I can draw dialog "live" like GC for the same reason I can't hook delete key into clear menu
// it's the window that gets the keypresses, and I don't have a window class.
- (IBAction)dialogOkButton:(id)sender
{
	if ( changingText == 0 )
		[theComicView renderText :[dialogCreationBox string] :[fontManager selectedFont]];
	else {
		changingText = 0;
		[theComicView replaceSelectedTextWithThis: [dialogCreationBox string] :[fontManager selectedFont]];
	}
    [boxTool setState :NSOffState];
    [arrowTool setState :NSOffState];
    [bubbleTool setState :NSOffState];
    [dialogWindow close];    
    [[[NSFontManager sharedFontManager] fontPanel:NO] close];
    [window makeKeyAndOrderFront: self]; // don't ask why, but I have to do this or click twice on the window
    [theComicView toolChange: 8]; // yeah, yeah, it's not in sequence. That's what happens, you know

    //    NSLog (@"%d", [fontManager isEnabled]);
//    NSLog (@"and the font it %@", [[fontManager selectedFont] fontName]);
}

- (IBAction)scaleCancelButton:(id)sender
{
    [scaleWindow close];    
}

- (IBAction)scaleOkButton:(id)sender
{
    if ( [scaleBox floatValue] > 0 && [scaleBox floatValue] < 10){
        [scaleWindow close];        
        [theComicView scaleCurrentSprite :[scaleBox floatValue]];
    } else
        NSRunAlertPanel(@"My Apologies",@"Please enter a value between .1 and some logical number less then 10.",@"OK",NULL,NULL);

}

- (IBAction)showScaleWindow:(id)sender
{
    [scaleWindow center];    
    [scaleWindow makeKeyAndOrderFront :sender];
}

- (IBAction)closeCancelButton:(id)sender
{
    NSMutableDictionary *layerZero= [NSMutableDictionary dictionaryWithCapacity: 1];
    NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];

    [closeWarningWindow close];
    [window performClose: sender];

    [layers removeAllObjects];
    [sprites removeAllObjects];
    [bordersArray removeAllObjects];

    [defaults setInteger:[layerPallet frame].origin.x forKey:@"layersX"];
    [defaults setInteger:[layerPallet frame].origin.y forKey:@"layersY"];
    [defaults setInteger:[spritePallet frame].origin.x forKey:@"spriteX"];
    [defaults setInteger:[spritePallet frame].origin.y forKey:@"spriteY"];
    [defaults setInteger:[toolsPallet frame].origin.x forKey:@"toolsX"];
    [defaults setInteger:[toolsPallet frame].origin.y forKey:@"toolsY"];

    [defaults synchronize];
    
    [layerPallet close];
    [spritePallet close];
    [toolsPallet close];
    [window close];

    [layerZero setObject :@"0" forKey:@"layer"];
    [layers addObject :layerZero]; // now I have one 100% opaque layer

    layerIncrementor = 0;
    [myDocument updateChangeCount: NSChangeCleared];
    state = readyToOpen;
    NSLog (@"Closed");
}

- (IBAction)cancelCloseButton:(id)sender
{
    if ( window != nil ){ // in case you, for some nutty reason, try to close a window you don't have open
        [window makeKeyAndOrderFront: self];
        [closeWarningWindow close]; // just close
    }
}

- (IBAction)closeSaveButton:(id)sender
{
    [self save:sender];
    [self closeCancelButton: sender];
}

- (IBAction)showCloseWarningWindow:(id)sender
{
    if ( [myDocument isDocumentEdited] ){
        [layerPallet close];
        [toolsPallet close];
        [spritePallet close];
    [closeWarningWindow center];
    [closeWarningWindow makeKeyAndOrderFront :sender];
    } else {
        [self closeCancelButton: sender];
    }
        
}

- (IBAction)preferencesSaveButton:(id)sender
{
    NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];

    NSData *theData=[NSArchiver archivedDataWithRootObject:[colorSelector color]];
    [[NSUserDefaults standardUserDefaults] setObject:theData forKey:@"backgroundColor"];
    
    [defaults setInteger:[defaultSaveFormat indexOfSelectedItem] forKey:@"defaultFormat"];

    [defaults synchronize];
    [preferencesWindow close];
    
}

- (IBAction)showpreferencesWindow:(id)sender
{
    [preferencesWindow center];    
    [preferencesWindow makeKeyAndOrderFront: sender];

    // read the value of the user default with key aKey
    // and return it in aColor
    NSColor * aColor =nil;
    NSData *theData= [[NSUserDefaults standardUserDefaults] dataForKey:@"backgroundColor"];
    if (theData != nil){
        aColor =(NSColor *)[NSUnarchiver unarchiveObjectWithData:theData];
        [colorSelector setColor: aColor];
        [defaultSaveFormat selectItemAtIndex: [[NSUserDefaults standardUserDefaults] integerForKey:@"defaultFormat"]];
    }
    
    
}


- (IBAction)showRotateWindow:(id)sender
{
    [rotateWindow center];    
    [rotateWindow makeKeyAndOrderFront :sender];

}

- (IBAction)transparentCancelButton:(id)sender
{
    [transparentWindow close];    
}

- (IBAction)transparentOkButton:(id)sender
{
    if ( [transparencyBox intValue] >= 0 && [transparencyBox intValue] <= 100){
        [transparentWindow close];        
        [theComicView makeSpriteTransparent :[transparencyBox intValue]];
    } else
        NSRunAlertPanel(@"My Apologies",@"Please enter a value between 0 and 100.",@"OK",NULL,NULL);
    
}

- (IBAction)showtransparentWindow:(id)sender
{
    [transparentWindow center];
    [transparentWindow makeKeyAndOrderFront :sender];

}

- (IBAction)up:(id)sender
{
    if ( [layerTable selectedRow] != 0 ){
        id theLayer = [[layers objectAtIndex:[layers count] - [layerTable selectedRow] - 1] retain];
        [layers removeObjectAtIndex:[layers count] - [layerTable selectedRow] - 1];
        [layers insertObject :theLayer atIndex:[layers count] - [layerTable selectedRow] + 1];
        [layerTable selectRow :[layerTable selectedRow] - 1 byExtendingSelection:NO];
        [self changeLayer];
    }
    [layerTable reloadData];
}


- (id)tableView:(NSTableView *)aTableView objectValueForTableColumn:(NSTableColumn *)aTableColumn row:(int)rowIndex
{

    id theRecord, theValue;
    if ([layerTable isEqual:aTableView ] ) {
    NSParameterAssert(rowIndex >= 0 && rowIndex < [layers count]);
    theRecord = [layers objectAtIndex:[layers count] - rowIndex - 1];
    theValue = [theRecord objectForKey:[aTableColumn identifier]];
    } else
    {
        NSParameterAssert(rowIndex >= 0 && rowIndex < [sprites count]);
        theValue = [sprites objectAtIndex:rowIndex];
    }
    return theValue;
}

- (void)tableView:(NSTableView *)aTableView
   setObjectValue:anObject
   forTableColumn:(NSTableColumn *)aTableColumn
              row:(int)rowIndex
{
    // I don't need this, I do my updating elsewhere
    return;
}

- (int)numberOfRowsInTableView:(NSTableView *)aTableView
{
    if ([layerTable isEqual:aTableView ] )
        return [layers count];
    else
        return [sprites count];
}

- (NSSize)windowSize
{
    return NSMakeSize([theComicView frame].size.width, [theComicView frame].size.height);
}

@end
