//
//  sprite.m
//  Sprite Comic Helper
//
//  Created by Robert Ziefel on Sun Jul 21 2002.
//  Copyright (c) 2001 __MyCompanyName__. All rights reserved.
//

#import "sprite.h"


@implementation sprite

-(id) init:(NSImage *)sprite :(NSRect)rect :(int)layer 
{
    self = [super init];
    imageData = [[NSImage alloc] initWithSize: NSMakeSize(rect.size.width, rect.size.height)];
    [imageData lockFocus];
    [sprite compositeToPoint:NSMakePoint(0, 0)
                    fromRect:rect
                   operation:NSCompositeSourceOver];
    [imageData unlockFocus];
    currentRect = rect;
    myLayer = layer;
    transparency = 100;
    return self;
}

-(NSImage *)sprite
{
    return imageData;
}

-(int)layer
{
    return myLayer;
}

-(void)incrementLayer :(int)theIncrement
{
//    NSLog (@"layer %d has juts become %d", myLayer, myLayer + theIncrement);
    myLayer += theIncrement;
}

-(NSRect)currentRect
{
    return currentRect;
}

-(void)setRect :(NSRect) rectToSet
{
    currentRect = rectToSet;
}

-(void)setTransparency:(int)value
{
    transparency = value;
}

-(int)transparency
{
    return transparency;
}

-(void)crop:(int)newStartX :(int)newStartY :(int)width :(int)height
{
    NSImage *tempImageData = [[NSImage alloc] initWithSize: NSMakeSize(width, height)];

//    NSLog (@"I am going to create a new image, and the x will be %d, the y is %d, which has a width of %d and a height of %d", newStartX , newStartY, width, height);
    
    [tempImageData lockFocus];
    [imageData compositeToPoint:NSMakePoint(0, 0)
                    fromRect:NSMakeRect(newStartX, newStartY, width, height)
                   operation:NSCompositeSourceOver];
    [tempImageData unlockFocus];
    
    [imageData setScalesWhenResized: NO];
    [imageData setSize: NSMakeSize (width, height)];

    [imageData lockFocus];
    [[NSColor clearColor] set];
    NSRectFill(NSMakeRect(0, 0, width, height));

    [tempImageData compositeToPoint:NSMakePoint(0, 0)
                       fromRect:NSMakeRect(0, 0, width, height)
                      operation:NSCompositeSourceOver];
    [imageData unlockFocus];
    
}

@end
